; ############################################### 

.386 
.model flat, stdcall 
option casemap :none ; case sensitive 

; ############################################### 

include \masm32\include\windows.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\setupapi.inc 
include \masm32\include\user32.inc  
include \masm32\include\gdi32.inc 

includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\setupapi.lib 
includelib \masm32\lib\user32.lib  
includelib \masm32\lib\gdi32.lib 
    
    ;================= 
    ; Local prototypes 
    ;================= 
    WndProc PROTO :DWORD, :DWORD, :DWORD, :DWORD 
    OutErrMsg PROTO :DWORD, :DWORD 
    DisplayAllDevices PROTO :DWORD

; ############################################### 

;=============== 
; Equates needed 
;=============== 
; .const 
    ANYSIZE_ARRAY equ 1 
    DIGCF_DEFAULT equ 1h 
    DIGCF_PRESENT equ 2h 
    DIGCF_ALLCLASSES equ 4h 
    DIGCF_PROFILE equ 8h 
    DIGCF_DEVICEINTERFACE equ 10h 
    
    ;=============== 
    ; Structs needed 
    ;=============== 
    SP_DEVICE_INTERFACE_DATA STRUCT 
    cbSize DWORD ? 
    InterfaceClassGuid GUID <> 
    Flags DWORD ? 
    Reserved DWORD ? 
    SP_DEVICE_INTERFACE_DATA ENDS 
    
    SP_DEVICE_INTERFACE_DETAIL_DATA STRUCT 
    cbSize DWORD ? 
    DevicePath BYTE ANYSIZE_ARRAY dup(?) 
    SP_DEVICE_INTERFACE_DETAIL_DATA ENDS 
    
    SP_DEVINFO_DATA STRUCT 
    cbSize DWORD ? 
    ClassGuid GUID <> 
    DevInst DWORD ? 
    Reserved DWORD ? 
    SP_DEVINFO_DATA ENDS 


.data 
    dlgname db "TESTWIN",0 
    hInstance dd ? 
    DeviceInfoSet dd ? 
    NewDeviceInfoSet dd ? 
    xTemp dd ? 
    
    CreateDeviceInfoList db "SetupDiCreateDeviceInfoList", 0 
    GetClassDevs db "SetupDiGetClassDevs", 0 
    EnumDeviceInterfaces db "SetupDiEnumDeviceInterfaces", 0 
    GetDeviceInterfaceDetail db "SetupDiGetDeviceInterfaceDetail", 0 
    szDASHES    db  "--------", 0

.data?

    Detect1Str db 26100 dup(?) 


.code 

start: 

; ############################################### 

    invoke GetModuleHandle, NULL 
    mov hInstance, eax 
    
    ; ------------------------------------------- 
    ; Call the dialog box stored in resource file 
    ; ------------------------------------------- 
    invoke DialogBoxParam,hInstance,ADDR dlgname,0,ADDR WndProc,0 
    
    invoke ExitProcess,eax 

; ############################################### 

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 

    .if uMsg == WM_INITDIALOG 
        invoke LoadIcon, NULL, IDI_ASTERISK 
        invoke SendMessage, hWin, WM_SETICON, 1, eax

        invoke SendDlgItemMessage, hWin, 110, LB_RESETCONTENT, 0, 0
        invoke DisplayAllDevices, hWin

    .elseif uMsg == WM_COMMAND 
        .if wParam == IDCANCEL 
            jmp short quit_dialog 
        .endif 

    .elseif uMsg == WM_CLOSE 
quit_dialog: 
        invoke EndDialog, hWin, 0 

    .endif 

    xor eax, eax 
    ret 
WndProc endp 

; ############################################### 

; 
; OutErrMsg PROTO :DWORD 
;
OutErrMsg proc uses ebx oeWin:DWORD, oeStr:DWORD
LOCAL buffer[256]:BYTE
    invoke GetLastError
    mov ebx, eax
    invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, 0, ebx, LANG_NEUTRAL,
        addr buffer, 200, 0

    ; remove ending CRLF from string
    invoke lstrlen, addr buffer
    sub eax, 2
    invoke lstrcpyn, addr Detect1Str, addr buffer, eax
    invoke lstrcat, addr Detect1Str, addr szDASHES
    invoke lstrcat, addr Detect1Str, oeStr

    ; Insert error string in the ListBox
    invoke SendDlgItemMessage, oeWin, 110, LB_ADDSTRING, 0, addr Detect1Str
    ret
OutErrMsg endp 

; ############################################### 

; 
; DisplayAllDevices PROTO :DWORD
;
DisplayAllDevices proc hWin:DWORD
local DeviceInfoData:SP_DEVINFO_DATA 
local DeviceInterfaceData:SP_DEVICE_INTERFACE_DATA 
local DeviceInterfaceDetailData:SP_DEVICE_INTERFACE_DETAIL_DATA 
local InterfaceClassGuid:GUID 
local DataT:DWORD
local buffer:DWORD
local longestbuffer:DWORD
local buffersize:DWORD
local dwLongestString:DWORD         ; Used for determining the horizontal scrollbar extent
local hDC:DWORD
local longeststringsize:SIZEL

    mov longestbuffer, 0
    mov dwLongestString, 0

    invoke SetupDiGetClassDevs, NULL, NULL, NULL, 
        DIGCF_PRESENT or DIGCF_ALLCLASSES
    mov NewDeviceInfoSet, eax 
    .if NewDeviceInfoSet != INVALID_HANDLE_VALUE 
        xor ecx, ecx 

        @@: 
        push ecx

        mov eax, sizeof SP_DEVINFO_DATA
        mov DeviceInfoData.cbSize, eax
        invoke SetupDiEnumDeviceInfo, NewDeviceInfoSet, ecx, addr DeviceInfoData
        .while eax != 0

            mov buffersize, 0
            mov buffer, 0
            
            invoke SetupDiGetDeviceRegistryProperty, NewDeviceInfoSet, 
                        addr DeviceInfoData, 0, addr DataT, buffer, 
                        buffersize, addr buffersize 
            .while eax == 0
                invoke GetLastError
                .if eax == ERROR_INSUFFICIENT_BUFFER
                    ; Change the buffer size.
                    .if buffer != 0
                        invoke LocalFree, buffer
                        mov buffer, 0
                    .endif
                    invoke LocalAlloc, LPTR, buffersize
                    mov buffer, eax
                .else
                    ; Insert error handling here.
                    .break
                .endif

                invoke SetupDiGetDeviceRegistryProperty, NewDeviceInfoSet, 
                            addr DeviceInfoData, 0, addr DataT, buffer, 
                            buffersize, addr buffersize 
                
            .endw

            ; Determine if this string is the largest found so far...
            invoke lstrlen, buffer
            .if eax > dwLongestString
                mov dwLongestString, eax

                ; Save a copy of the longest string found yet.
                .if longestbuffer != 0
                    invoke LocalFree, longestbuffer
                    mov longestbuffer, 0
                .endif
                invoke LocalAlloc, LPTR, dwLongestString
                mov longestbuffer, eax
                invoke lstrcpy, longestbuffer, buffer
            .endif

            ; Add this string to the listbox
            invoke SendDlgItemMessage, hWin, 110, LB_ADDSTRING, 0, buffer

            .if buffer != 0
                invoke LocalFree, buffer
                mov buffer, 0
            .endif

            pop ecx
            inc ecx
            push ecx
            invoke SetupDiEnumDeviceInfo, NewDeviceInfoSet, ecx, addr DeviceInfoData

        .endw
        pop ecx

        invoke SetupDiDestroyDeviceInfoList, DeviceInfoSet

        ; Reset the horizontal scrollbar extent so that we can view the longest string.
        invoke GetDC, hWin
        mov hDC, eax
        invoke lstrlen, longestbuffer
        push eax
        mov edx, eax
        invoke GetTextExtentPoint32, hDC, longestbuffer, edx, addr longeststringsize
        invoke SendDlgItemMessage, hWin, 110, LB_SETHORIZONTALEXTENT, longeststringsize.x, 0
        invoke ReleaseDC, hWin, hDC
        .if longestbuffer != 0
            invoke LocalFree, longestbuffer
            mov longestbuffer, 0
        .endif
    .endif

    ret
DisplayAllDevices endp

; ############################################### 

end start
